; Set up environment.
#NoEnv
#SingleInstance, Off
#NoTrayIcon
SetBatchLines, -1
SetControlDelay, -1
DetectHiddenWindows, On
SetWorkingDir, %A_ScriptDir%

IniRead, rMBU, % A_ScriptDir . "\config.ini", Rates, MBU, 0.10
IniRead, rMBD, % A_ScriptDir . "\config.ini", Rates, MBD, 0.17
IniRead, rPUT, % A_ScriptDir . "\config.ini", Rates, PUT, 0.01
IniRead, rGET, % A_ScriptDir . "\config.ini", Rates, GET, 0.01
IniRead, rGBS, % A_ScriptDir . "\config.ini", Rates, GBS, 0.15
IniRead, MBU , % A_ScriptDir . "\config.ini", Values, MBU, 0
IniRead, MBD , % A_ScriptDir . "\config.ini", Values, MBD, 0
IniRead, PUT , % A_ScriptDir . "\config.ini", Values, PUT, 0
IniRead, GET , % A_ScriptDir . "\config.ini", Values, GET, 0
IniRead, GBS , % A_ScriptDir . "\config.ini", Values, GBS, 0

GoSub, Gui_Build_Main
GoSub, Calc

Gui, 1: Show, AutoSize Center, JungleCalc

Return ; End of auto-execute section.


Gui_Build_Main:
{
    Gui, 1: Margin, 3, 5
    Gui, 1: Add, Text     , xm    ym     w90  h20 Right 0x200                , GB uploaded:
    Gui, 1: Add, Edit     , xm+95 ym     w80  h20 Right          vMBU   gCalc, % MBU
    Gui, 1: Add, Text     , xm    ym+25  w90  h20 Right 0x200                , GB downloaded:
    Gui, 1: Add, Edit     , xm+95 ym+25  w80  h20 Right          vMBD   gCalc, % MBD
    Gui, 1: Add, Text     , xm    ym+50  w90  h20 Right 0x200                , PUT requests:
    Gui, 1: Add, Edit     , xm+95 ym+50  w80  h20 Right          vPUT   gCalc, % PUT
    Gui, 1: Add, Text     , xm    ym+75  w90  h20 Right 0x200                , GET requests:
    Gui, 1: Add, Edit     , xm+95 ym+75  w80  h20 Right          vGET   gCalc, % GET
    Gui, 1: Add, Text     , xm    ym+100 w90  h20 Right 0x200                , GB stored:
    Gui, 1: Add, Edit     , xm+95 ym+100 w80  h20 Right          vGBS   gCalc, % GBS
    Gui, 1: Add, GroupBox , xm    ym+120 w175 h8
    Gui, 1: Add, Button   , xm    ym+135 w40  h20                       gGui_Build_Rates, &Rates
    Gui, 1: Add, Text     , xm+45 ym+135 w45  h20 Right 0x200                , $/month:
    Gui, 1: Add, Edit     , xm+95 ym+135 w80  h20 Right ReadOnly vTotal      ,
    Gui, 1: +LastFound
    GUI_ID := WinExist()
}
Return


GuiEscape:
GuiClose:
{
    Gui, 1: Submit, NoHide
    IniWrite, % MBU, % A_ScriptDir . "\config.ini", Values, MBU
    IniWrite, % MBD, % A_ScriptDir . "\config.ini", Values, MBD
    IniWrite, % PUT, % A_ScriptDir . "\config.ini", Values, PUT
    IniWrite, % GET, % A_ScriptDir . "\config.ini", Values, GET
    IniWrite, % GBS, % A_ScriptDir . "\config.ini", Values, GBS
    ExitApp
}
Return


Gui_Build_Rates:
{
    Gui, 2: +Owner1
    Gui, 1: +Disabled
    WinGetPos, X, Y, , , % "ahk_id " . GUI_ID
    Gui, 2: Margin, 3, 5
    Gui, 2: Add, GroupBox, xm     ym     w220 h150 Section                 , Rates
    Gui, 2: Add, Text    , xs+5   ys+20  w200 h20  0x200                   , $                per GB of data uploaded
    Gui, 2: Add, Edit    , xs+15  ys+20  w40  h20  Right   vrMBU           , % rMBU
    Gui, 2: Add, Text    , xs+5   ys+45  w200 h20  0x200                   , $                per GB of data downloaded
    Gui, 2: Add, Edit    , xs+15  ys+45  w40  h20  Right   vrMBD           , % rMBD
    Gui, 2: Add, Text    , xs+5   ys+70  w200 h20  0x200                   , $                per 1000 upload requests
    Gui, 2: Add, Edit    , xs+15  ys+70  w40  h20  Right   vrPUT           , % rPUT
    Gui, 2: Add, Text    , xs+5   ys+95  w200 h20  0x200                   , $                per 10,000 download requests
    Gui, 2: Add, Edit    , xs+15  ys+95  w40  h20  Right   vrGET           , % rGET
    Gui, 2: Add, Text    , xs+5   ys+120 w200 h20  0x200                   , $                per GB-month of storage used
    Gui, 2: Add, Edit    , xs+15  ys+120 w40  h20  Right   vrGBS           , % rGBS
    Gui, 2: Add, Button  , xm+180 ym+155 w40  h20  Default       g2GuiClose, OK
    Gui, 2: Show, % "x" . X + 20 . " y" . Y + 20, Rates
}
Return


2GuiEscape:
2GuiClose:
{
    Gui, 2: Submit, NoHide
    IniWrite, % rMBU, % A_ScriptDir . "\config.ini", Rates, MBU
    IniWrite, % rMBD, % A_ScriptDir . "\config.ini", Rates, MBD
    IniWrite, % rPUT, % A_ScriptDir . "\config.ini", Rates, PUT
    IniWrite, % rGET, % A_ScriptDir . "\config.ini", Rates, GET
    IniWrite, % rGBS, % A_ScriptDir . "\config.ini", Rates, GBS
    
    Gui, 1: -Disabled
    Gui, 1: Default
    Gui, 2: Destroy
    
    GoSub, Calc
}
Return


Calc:
{
    Gui, 1: Submit, NoHide
    % ( GBS = "" OR GBS <= 5 ) ? ( GBs := 0 ) : ()
    % ( MBU = "" )             ? ( MBU := 0 ) : ()
    % ( MBD = "" )             ? ( MBD := 0 ) : ()
    % ( PUT = "" )             ? ( PUT := 0 ) : ()
    % ( GET = "" )             ? ( GET := 0 ) : ()
    GuiControl, 1: Text, Total, % ( Round( ( GBS * rGBS ) 
                                         + ( MBU * rMBU )
                                         + ( MBD * rMBD )
                                         + ( ( PUT * rPUT ) / 1000 )
                                         + ( ( GET * rGET ) / 10000 ), 2) )
}
Return









